//
//  GestorPuntuaciones.m
//  EjemploTablaDatos
//
//  Created by imacrcanales on 05/11/12.
//  Copyright (c) 2012 Autentia. All rights reserved.
//

#import "GestorPuntuaciones.h"
#import "Gestor.h"


@implementation GestorPuntuaciones 

@synthesize puntuaciones;

- (id)init
{
    NSLog(@">>>>>>>>>>>>>>>> inicializamos el objeto");
    
    // inicializamos el objeto
    self.puntuaciones = [[NSMutableArray alloc] init];
    return [super init];
}

-(NSInteger)sumaPuntuacion: (Puntuacion*) nuevaPuntuacion
{
    [self.puntuaciones addObject:nuevaPuntuacion];
    
    NSLog(@">>>>>>>>>>Añadimos objeto");
    
    
    for (id obj in self.puntuaciones)
    {
        NSLog(@">>>>>>>>>Puentuaciones DES - ordenadas: %d", (int) ((Puntuacion*)obj).puntuacion);
    }
    
    NSArray* arrayAux2 = [self.puntuaciones sortedArrayUsingComparator:^NSComparisonResult(id a, id b) {
        
        NSInteger *pUno = ((Puntuacion*)a).puntuacion;
        NSInteger *pDos = ((Puntuacion*)b).puntuacion;
        
        if( pUno > pDos)
            return NSOrderedAscending;
        if( pUno == pDos)
            return NSOrderedSame;
        return NSOrderedDescending;
    }];
    
    self.puntuaciones = [arrayAux2 mutableCopy];
    
    for (id obj in self.puntuaciones)
    {
        Puntuacion* pp = (Puntuacion*)obj;
        NSLog(@">>>>>>>>>Puentuaciones ordenadas: %d", (int) pp.puntuacion);
    }
    
    // podiamos aquí borrar las estras que superen el máximo que nos pongamos
    return [self.puntuaciones count];
}

-(NSInteger)numeroPuntuaciones;
{
   return [self.puntuaciones count];
}


-(Puntuacion*)damePuntuacionConClave: (NSInteger) clave{
    
    return [self.puntuaciones objectAtIndex:clave];
}


@end